class SketchupIvy ###################################
  @@lines  = []
  @@leaves = []

  def initialize
    @ip      =nil
    @point   = nil
    @@leaves = []
    @step    = 0
    @@lines  = []
    @ip      =Sketchup::InputPoint.new
  end

  def getExtents
    bb = Sketchup.active_model.bounds.add(@@lines)
    return bb
  end

  def self.addlines(l)
    @@lines.concat(l)
  end

  def self.addleaves(l)
    @@leaves.concat(l)
  end

  def self.lines
    @@lines
  end

  def suspend(view)
  end

  def activate(view)
  end

  def resume(view)
    #self.draw(view)
  end

  def onMouseMove(flags, x, y, view)
    @ip.pick(view, x, y)
    @ip.draw(view)
  end

  def onLButtonUp(flags, x, y, view)
    #self.draw(view)
  end

  #def

  def onLButtonDown(flags, x, y, view)
    @ip.pick(view, x, y)
    if @ip.valid? && flags == 1
      @point=@ip.position
      @ip.clear
      unless @iv
        load "si.rb"
        eye    = Sketchup.active_model.active_view.camera.eye
        vector = Sketchup.active_model.active_view.camera.eye.vector_to(@point)
        puts intersect = Sketchup.active_model.raytest([eye, vector])
        @iv = Si::Ivy.new(intersect[0], intersect[1].last.normal)
      end
      @iv.auto
    elsif flags == 9 && @iv
      #@iv.densify_leaves
    elsif flags == 5 && @iv
      @iv.birth
      Sketchup.send_action("selectSelectionTool:")
    end #if
    view.refresh
  end

  #def
  def draw(view)
    view.drawing_color = "red" if @@lines
    view.draw_line @@lines if @@lines.last
    #view.draw_points @@leaves if @@leaves.last
    @ip.draw(view) if @ip and @ip.valid?

  end
end
#class ######################################
require "sketchup"
if not file_loaded?("IvyTool.rb")
  plugins_menu = UI.menu("Plugins")
  item         = plugins_menu.add_item("SketchupIvy") { Sketchup.active_model.select_tool SketchupIvy.new }
end
file_loaded("IvyTool.rb")